<HTML>
<HEAD>
   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">
   <META NAME="GENERATOR" CONTENT="Mozilla/4.04 [en] (X11; I; SunOS 5.6 sun4u) [Netscape]">
</HEAD>
<h1>Creation of an LDAS database</h1>
<BODY>
<p><b><font color='red'>The steps described below are to be executed under database user ldasdb.</b></font>
Please visit IBM DB2 web site for details 
<a href="http://www.ibm.com/software/data/db2/">
IBM DB2 web site </a> for DB2 specifics.
<p>
<h3><a href="installDB2.html">Installation of IBM DB2</a></h3><p>
If DB2 software has not been installed, follow the directions in this link
to install DB2 software. Otherwise skip this step.
<p>
<p><h3><u>Establish the correct include/library links for LDAS</u></h3><p>
The link /ldcg/IBMdb2 points to the current IBM installation include and library
files to be used in compilation of LDAS software and running of utilities
invoking db2 clients.<p>
Any time a new IBMdb2 installation is performed, the headers and shared libraries in
/ldcg/IBMdb2 must be updated to point to the new installation. <p>
As user <font color='brown'>install</font>, perform the following steps:
<p>
<ol>
<li>Create a new directory under /ldcg/stow_pkgs: e.g. for IBMdb2 V8.2.1,
<font color='brown'><pre>
mkdir IBMdb2-8.2.1
mkdir IBMdb2-8.2.1/IBMdb2
mkdir IBMdb2-8.2.1/IBMdb2/include
mkdir IBMdb2-8.2.1/IBMdb2/lib
</pre></font><p></li>
<li>Upload or copy ( if standalone box ) the include files from DB2 instance <i>ldasdb</i> sqllib/include 
to /ldcg/stow_pkgs/IBMdb2-8.2.1/IBMdb2/include via sftp. e.g.<p>
<font color='brown'><pre>
cd  ~ldasdb/sqllib/include
sftp install@gateway
> cd /ldcg/stow_pkgs/IBMdb2-8.2.1/IBMdb2/include
> puts *
<font color='black'>or</font>
cp ~ldasdb/sqllib/include/* /ldcg/stow_pkgs/IBMdb2-8.2.1/IBMdb2/include
</pre></font><p></li>
<li>Upload or copy (if standalone box ) the library files from DB2 instance <i>ldasdb</i> sqllib/lib 
to /ldcg/stow_pkgs/IBMdb2-8.2.1/IBMdb2/lib via sftp. e.g.<p>
<font color='brown'><pre>
cd  ~ldasdb/sqllib/lib
sftp install@gateway
> cd /ldcg/stow_pkgs/IBMdb2-8.2.1/IBMdb2/lib
> puts *
<font color='black'>or</font>
cp ~ldasdb/sqllib/lib/* /ldcg/stow_pkgs/IBMdb2-8.2.1/IBMdb2/lib
</pre></font><p></li></font>
<li><font color='black'>Unstow the old installation if any and stow the new installation:
<font color='brown'><pre>
cd  /ldcg/stow_pkgs
stow -D IBMdb2-8.1.5
stow IBMdb2-8.2.1
</pre></font>
<p>
</ol>
<p><h3><u>Configuring for LDAS applications</u></h3><p>
<p>
The following modifications to the configuration parameters are recommended
for running DB2 with LDAS system: <p>
<ol>
    <li>Set database manager system grop to ldas so user ldas can 
    create/drop databases or other administrative work. 
	<pre><font color='brown'>
	db2 &gt; UPDATE DBM CFG USING SYSTEM_GROUP LDAS
	</font></pre>
	<li>Increase query heap size
	e.g. for a SUN server with 4 GB memory, we set it to 40000 4 KB pages
	but you should tailor this to your system's configuration.    
	<pre><font color='brown'>
	db2 &gt; UPDATE DBM CFG USING QUERY_HEAP_SZ 40000
	</font></pre>
	<li>Increase size of the secondary log files for the database after
	a database has been created. e.g. increase to 100
	<pre><font color='brown'>
	db2 &gt; update database configuration for &lt;your database&gt; using logsecond 100
	</font></pre>
    <li>Set the size of locklist to 400 to avoid time out from obtaining a lock on the database
	<pre><font color='brown'>
	db2 &gt; update database configuration for &lt;your database&gt; using locklist 400
	</font></pre>
	This command is done by <a href="../text/createall">createall </a>script 
	when it is used to create a new database.
	</li><p> 
</ol>
<p>
</ol>
<p><h3><u>Configuring for multithreaded applications</u></h3><p>
For platforms that can support multiple threads, the following is recommended
in the IBM DB2 documentation to reduce contention and potential deadlocks
in applications accessing the database: <p>
<ol>
	<li>Setting environment variable DB2_FORCE_NLS_CACHE to TRUE will cause
	the code page and country code to be saved in cache
	the first time a thread accesses it. The cached information will be available
	for subsequent threads as long as the application does not change settings
	between connections. </li><p>
	<li>Have a time out value (in seconds) for database configuration parameter LOCKTIMEOUT
	instead of the default value of -1. If there is a deadlock execution can
	resume by timing out the transaction that is unable to request the database
	lock.<p> You can set the database parameter via the db2 client:
	<font color='brown'>
	<pre>db2 => update database configuration for ldas_tst using locktimeout 10</pre></font>
	</li><p> 
</ol>

<p><h3><a href="startstop.html">Start/Stop Database Manager</a></h3><p>
If the database manager has not been started yet, following the directions in this link 
for starting the database manager. Otherwise skip this step.
<p>
<p><h3><a href="dbChanges.html">Make changes to an existing LDAS database</a></h3><p>
After you have created the database as described under <a href='#CREATEDB'>Create database</a>, 
check this link for steps to follow when making changes to an LDAS database.

<p><h3><a href="validateLDAS.html">Validate LDAS database functionality</a></h3><p>
If the IBM DB2 software has been updated or databases have been restored,
you can follow these steps to <a href='validateLDAS.html'>validate LDAS database functionality
</a>is intact.
<p>
<A name="CREATEDB">
<h3>Create database</h3>
<p>To create database tables in db2, create the directory for holding the database
files by doing mkdir <directory>, then run db2 client utility <i>db2</i> in command mode
and issue the following:
<p>
db2 => create database &lt;dbname&gt; on &lt;directory&gt; alias &lt;dbname&gt;

e.g.<font color='brown'><pre>
mkdir /usr1/databases  </pre></font>(if the above directory does not exist )
<font color='brown'><pre>
db2 => create database dev_test on /usr1/databases alias dev_test

</pre></font>

<p>The sql and shell scripts mentioned below can be obtained by downloading
the package <a href='http://www.ldas-sw.ligo.caltech.edu/packages'>db2-table-0.n.m.tar.gz</a>
where n and m are major and minor version numbers, e.g. db2-table-0.2.4. 
To unpack the package, use the command `gzip -dc db2-table-0.n.m.tar.gz | tar xf- '. 
This will create the sub-directory db2-table-0.n.m with the scripts in it. 

<A name="CREATETBL">
<h3>Create LDAS tables</h3>
The two simplest ways to create all of the LDAS database tables are 
<ol>
<li> Use cmonClient: select LDAS control -> LDAS utilities -> 
<a href="../../../userAPI/html/cmonClient-control.html#dbCreate">
create new database </a></li><p>
<li> As user ldas, run the LDAS script /ldas/bin/createLDASdb &lt;database alias&gt; &lt;database path&gt;
e.g.<pre><font color='brown'>/ldas/bin/createLDASdb new_db /usr1/databases </font></pre></a></li><p>
<li> Use shell script <a href="../text/createall">createall</a> &lt;dbname&gt;
<ol> 
<li>db2 'connect to &lt;database-name&gt; user &lt;db-user&gt; using &lt;db-password&gt;'</li>
<p><font color='brown'><pre>
   Database Connection Information

 Database server        = DB2/SUN 8.2.1
 SQL authorization ID   = LDASDB
 Local database alias   = dev_test
</pre></font>

<li>cd to directory connecting createall.sh and the sql scripts mentioned below.</li>
<p>
<li>Run the shell <a href="../text/createall">createall</a></i> &lt;dbname&gt; 
to create all the tables in the database, e.g.
<font color='brown'><pre>
./createall dev_test
</pre></font>
createall invokes<p>
<ol>
<li><a href='tables.html'>Individual sql scripts</a> for creating tables.</li><p>
<li><A name="TRIGGERS">Sql scripts to create triggers: after the tables have been created successfully, add the database
triggers that are used to remove the child record reference when
the parent record is deleted, e.g. sngl_datasource and sngl_transdta
reference one of the events tables; when the parent event table is
deleted e.g. sngl_inspiral, the trigger is invoked to remove the corresponding 
sngl_datasource and sngl_transdata record.
<p>To create database triggers in db2, run the listed sql scripts below with db2
client utility <i>db2</i> in command mode:<p>
db2 -f &lt;script-file&gt; (one of the following) 
<BR>&nbsp;
<ul>
<li><a href="../text/gds_trigger_tr_del.sql">gds_trigger_tr_del.sql</a></li>  
<li><a href="../text/sngl_dperiodic_tr_del.sql">sngl_dperiodic_tr_del.sql</a></li>
<li><a href="../text/sngl_ringdown_tr_del.sql">sngl_ringdown_tr_del.sql</a></li>
<li><a href="../text/sngl_burst_tr_del.sql">sngl_burst_tr_del.sql</a></li>
<li><a href="../text/sngl_inspiral_tr_del.sql">sngl_inspiral_tr_del.sql</a></li>
<li><a href="../text/sngl_unmodeled_tr_del.sql">sngl_unmodeled_tr_del.sql</a></li>
</ul></li>
<p>
<li><a href='#GRANT'><a href="../text/grant.sql">grant.sql</a> script to grant table access permission</a>
<p>This script issues a revoke command to deny permissions on a table
and then issues the new permissions. 
<font color='brown'><pre>
echo table runlist;
revoke all on table runlist from public;
grant select on table runlist to public;
</pre></font>

The revoke command will report errors the very first it
is ran on a table since the table does not have the necessary permissions:
<font color='brown'><pre>table process
DB21034E  The command was processed as an SQL statement because it was not a 
valid Command Line Processor command.  During SQL processing it returned:
SQL0556N  An attempt to revoke a privilege from "PUBLIC" was denied because 
"PUBLIC" does not hold this privilege.  SQLSTATE=42504

DB20000I  The SQL command completed successfully.
</pre></font>
but the second command of granting permissions should complete successfully.
<font color='brown'><pre>DB20000I  The SQL command completed successfully.</pre></font>
</li>
</ul>

</ul>
</li>
</ol>
<p>
<h3>Scripts to automate table selection and deletion</h3>
Run scripts as user ldasdb or 
connect to db2 as follows:
<font color='brown'><pre>	db2 'connect to &lt;dbname&gt; user &lt;dbuser&gt; using &lt;dbuser-password&gt;'</pre></font>
<p>
<ul>
<p>The following scripts can be used to retrieve data from
all tables created by the shell script createall:
<p>
e.g. db2 -tf selectall.sql 
<p>
<li>Select data from all tables: <a href="../text/selectall.sql">selectall.sql</a></li>
<p>
<li>To delete all data from the database server:
<BR>&nbsp; <a href="../text/delall.sql">delall.sql</a></li>
<p>
<li>To drop all tables from the database server:
<BR>&nbsp; <a href="../text/dropall.sql">dropall.sql</a></li>
</ul>
<p>
To terminate db2 connection, enter:
<font color='brown'><pre>	db2 terminate.</pre></font>
<p>
</ol>
<A name="DB2LDAS">
<h3>How to link a database to your LDAS system</h3>
<p>To make your database known to your LDAS system, LDAS resources files
must be configured, either by editing them or by running programs
to generate the configuration files. <font color='red'>This process must be done as
user ldas instead of user ldasdb for proper file ownership.</font>
The following resource files must be configured:
<ol>
<p>
<li>Where is db2 client? LDAS database web pages resource file /ldas_outgoing/LDASdb2utils.rsc<p>
<p>This file is used by the utility db2utils to build the database web pages at the sites
under the
<a href='http://www.ldas-dev.ligo.caltech.edu/ldas_outgoing/logs/LDASdatabase.html'>
LDAS database</a> link (the example shown is for site ldas-dev).
In addition, this file is also used by the scripts <i>dbUniqueIds</i> and <i>dbDsnames</i>
described below to generate site information for the metadataAPI. 
<p>Make a copy of this file from /ldas/bin/LDASdb2utils.rsc to /ldas_outgoing.
Edit the following variables in the file to reflect the db2 paths of your installation:
<p>
<font color='brown'><pre>
;## path of db2 client
set ::db2 "/usr2/ldasdb/sqllib/bin/db2" 
;## path of database directory
set ::dbdir "/usr1/databases"
</pre></font>
<p>Make sure environment DB2INSTANCE is set to your database user by doing
<font color='brown'><pre>setenv DB2INSTANCE &lt;dbuser&gt;</pre></font> in csh or
<font color='brown'><pre>set DB2INSTANCE=&lt;dbuser&gt; ; export DB2INSTANCE</pre></font> in Bourne shell.
<p>
<li>What are the database users and passwords ? metadataAPI database name file /ldas_outgoing/LDASdsnames.ini<p>
This file keeps track of the database users and their passwords for each database at the site.
<font color='brown'><pre>
cd /ldas_outgoing
/ldas/bin/dbDsnames

</pre></font>
<p>
When the screen comes up with the list of databases at your site, enter the
logins ( or use the defaults ) and passwords ( echoed with * ) and hit
the APPLY button. When completed, it displays a message that the
LDASdsnames.ini file has been created. The LDASdsname
contains the following lines for each database
<font color='brown'><pre>
array set &lt;your dbname&gt; { login { ldasdb &lt;encoded password&gt; } }

</pre></font> and a line showing all databases at your site:
<font color='brown'><pre>
array set ::site_dbnames { ldas-dev { dev_1 ldas_tst dev_test } }
</pre></font>
<p>
<li>How are passwords to connect for database page information being set up? 
<p>This is done in the LDAS database web pages resource file: /ldas_outgoing/cntlmonAPI/LDASdb2utils.rsc 
<p>The database user name and password have to be defined for the utility db2utils
( started by cntlmonAPI ) to connect to the database and retrieve information to build the web pages.
<p>Edit the LDASdb2utils.rsc file again to put in the password from 
the LDASdsnames.ini file and to set your database machine name:
<font color='brown'><pre>
;## database user password 
set ::dblock &lt;encoded-password&gt; 
set ::host <database machine name>
</pre></font> 
<p>
<li>Which is the default database for metadataAPI? LDAS global resource file: <i>/ldas_outgoing/LDASapi.rsc</i></li><p>
This file contains the variable to tell the metadataAPI which database to open
as default.
<p>Copy this file from the ldas installation ldas-0.0/bin to the run directory 
/ldas_outgoing. Enter your database name as the default database for your domain
on the line below:
<font color='brown'><pre>
set ::DATABASE_NAME dev_test
</pre></font>
<p>
The following variable should be set to the database instance in 
the managerAPI's resource file <i>/ldas_outgoing/LDASmanager.rsc</i></li><p>
<p><font color='brown'><pre>
;## desc=database user Id
set ::DB2INSTANCE ldasdb
</pre></font>
and also in the LDAS startup script runLDAS:
<p><font color='brown'><pre>
/usr/bin/env HOST=dataserver PATH=@prefix@/bin:/ldcg/bin:${PATH} LD_LIBRARY_PATH=
@prefix@/lib:@DB2_LIBS_DIR@:/ldcg/lib:${LD_LIBRARY_PATH} 
DB2INSTANCE=ldasdb 
/bin/nohup managerAPI $1 1>manager.log 2>&1 &
</pre></font>
<p>
In the LDAS build process, the path of the IBM db2 library should have been resolved 
with the expansion of @DB2_LIBS_DIR@ variable to the actual path of the IBM db2 directory.
<p>e.g. in the LDASmanager rsc file:
<font color='brown'><pre>
set ::LD_LIBRARY_PATH ${::LDAS}/lib:/ldcg/lib:@DB2_LIBS_DIR@
</pre></font>
<p>should become the following in the build target:
<font color='brown'><pre>
;## desc=dynamic load lib path ! mod=no
set ::LD_LIBRARY_PATH ${::LDAS}/lib:/ldcg/lib:/ldcg/IBMdb2/lib

</pre></font>
<p> and the runLDAS script should have the actual DB2 path in the build target: 
<font color='brown'><pre>
/usr/bin/env HOST=dataserver PATH=/ldas/bin:/ldcg/bin:${PATH} 
LD_LIBRARY_PATH=/ldas/lib:/ldcg/IBMdb2/lib:/ldcg/lib:${LD_LIBRARY_PATH} 
DB2INSTANCE=ldasdb 
/bin/nohup managerAPI $1 1>manager.log 2>&1 &
</pre></font>
<p>If you need to hard code the IBM DB2 path, you can edit the LDASmanager.rsc file
to have the actual IBM DB2 path e.g. if path is /usr/IBMdb2/V8.2.1/lib, in
LDASmanager.rsc file:
<pre><font color='brown'>
;## desc=dynamic load lib path ! mod=no
set ::LD_LIBRARY_PATH ${::LDAS}/lib:/ldcg/lib:/usr/IBMdb2/V8.2.1/lib
</font></pre>

<p>
For systems running on linux, LDAS must be build to link with the IBM db2 libraries.
See <a href=http://www.ldas-dev.ligo.caltech.edu/doc/INSTALL_SUITE.html>How to build LDAS</a>
for more details.<p>


<li>Start LDAS via cmonClient: cmonClient resource file: <i>/ldas/lib/cmonClient/cmonClient.rsc</i></li><p>
If you are using the cmonClient package, either from the ldas installation
or locally on your system with the gzip tar package, you should edit the cmonClient.rsc
file to include your database name.
<font color='brown'><pre>
;## desc=ldas dsnames at each site
array set ::dbnames { &lt;your domain&gt; { &lt;dbname1&gt; ...} }
array set ::dbnames { ldas-dev { dev_test dev_1 ldas_tst } }
<p></pre></font>
</ol>
<p>If you have more than one database, only one of them can be set as the
default database. But add the names of the other databases to the 
list of dbname arrays in the above files.
This is only needed if you want to use the cmonClient
to start your LDAS system for the first time so it has to know
about the site databases. Once cmonClient connects to
the LDAS cntlmonAPI server, the site database information will be downloaded to
the client.

<p>After the resources files are configured, you must reboot your LDAS system
to have the changes in effect. The metadataAPI log indicates which database
it has inserted to based on the specification in the -database option of the
user command  or use the
default database if the -database option is not specified e.g.
<font color='brown'><pre>
750200312 LDAS-DEV16969219 metadata::submitInsertReaper putMetaData inserted 6 rows into ldas_tst database
 table process at the rate of 216.08306 rows/sec, took walltime 0.02777 secs
750200312 LDAS-DEV16969219 metadata::submitInsertReaper putMetaData inserted 100 rows into ldas_tst database 
table gds_trigger at the rate of 2223.40804 rows/sec, took walltime 0.04498 secs
</pre></font>
<p>You can now use LIGO tool GUILD to submit queries or submit LDAS commands via the 
<a href="../../../userAPI/html/cmonClient-ldastest.html">cmonClient LDAS Test Panel</a>.


<hr width=100%>
<address>Last modified Oct 14th, 2003<br>
<p>Suggestions or Comments? Please Contact&nbsp; <a href="mailto:mlei@ligo.caltech.edu">mlei@ligo.caltech.edu</a>
<br>&nbsp;
<br>&nbsp;
<br>&nbsp;
<br>&nbsp;
<br>&nbsp;
</body>
</BODY>
</HTML>
